local leadWire = ...

--------------------------------------------------------------------------
local DECORATION_COMP = {
	TypeName = _PrefixAsset .. "_DECORATION_COMP",
	ParentType = "COMPONENT",
	Properties = {
            { Name = "FlagInitialPosition", Type = "boolean", Default = true, Flags = { "SAVE_GAME" }},
            { Name = "InitialPosition", Type = "vec3f", Flags = { "SAVE_GAME" }},
        }
}

--------------------------------------------------------------------------
function DECORATION_COMP:create()
   FlagInitialPosition = true
end

--------------------------------------------------------------------------
function DECORATION_COMP:init()
    if self.FlagInitialPosition then
        self.InitialPosition = self:getOwner():getGlobalPosition()
        self.FlagInitialPosition = false
    end

    leadWire:log("InitialPosition = " .. tostring(self.InitialPosition))
    self:majPosition()
end

function DECORATION_COMP:majPosition()
        self.WindowPosition = self:getOwner():getGlobalPosition()
        leadWire:log("Start GlobalPosition = " .. tostring(self:getOwner():getGlobalPosition()))
        if self:computeElevation() then
            self:getOwner():setGlobalPosition(self.WindowPosition)  
            self.InitialPosition = self:getOwner():getGlobalPosition()
            self.LeadWire_PositionY = self.WindowPosition[2]
            leadWire:log("<<<<<<Elevation y = " .. self.WindowPosition[2])
        else
            self:restorePosition()
        end
        leadWire:log("End GlobalPosition = " .. tostring(self:getOwner():getGlobalPosition()))
end

function DECORATION_COMP:restorePosition()
        leadWire:log("restore InitialPosition = " .. tostring(self.InitialPosition))
        if self.InitialPosition == nil then
            leadWire:log("InitialPosition nil")
            return
        end
        self:getOwner():setGlobalPosition(self.InitialPosition)
        self.LeadWire_PositionY = self.InitialPosition[2] 
        leadWire:log("restore InitialPosition end")
end

--------------------------------------------------------------------------
function DECORATION_COMP:computeElevation()
        local LeadWireName = _PrefixAsset .. "_LEAD_WIRE_COMP"
       
        local _currentObject = self:getOwner() 
        local _leadWire
        for i=0,20, 1 do
            local _parent = _currentObject:getParent()
            if _parent == nil then    
                return false
            end
            if _parent.Name == _PrefixAsset .. "_MONUMENT_NAME" then    
                _leadWire = _parent:findFirstObjectWithComponentDown(LeadWireName)        
                if _leadWire == nil then
                    return false
                end
                break
            end
            _currentObject = _parent
        end
        if not _leadWire.LeadWire_IsSet then
            return false
        end
        if _leadWire:getOwner() == nil then    
            return false
        end
        local _leadWireObject = _leadWire:getOwner()
        self.WindowPosition[2] = _leadWireObject:getGlobalPosition()[2]
        return true       
end

--------------------------------------------------------------------------
function DECORATION_COMP:update()
        if (self.LeadWire_PositionY - self:getOwner():getGlobalPosition()[2]) < 0.01 then
            return
        end
        self:majPosition()
end

--------------------------------------------------------------------------
leadWire:registerClass(DECORATION_COMP)
